//***************** Tortue 3D ***************** Ne pas modifier *****************
#include "definition.inc"
#declare epaisseurTraits=0.03;
#declare TortuePos = <0,0,0>;
#declare TortueAvant = <0,0,1>;
#declare TortueHaut = <0,1,0>;
#declare Tortuedroite = <1,0,0>;
#declare TortueCrayon = true;
#declare TortueEpais = epaisseurTraits;
#declare TortueCouleur = <0,0,0,0>;
#declare TortueRemplis = false;
#declare TortueCouleurRemplis = <1,1,0,0>;
#declare TortuePointAncrage = <0,0,0>;
#macro avance(d)
   #local Temp = TortuePos + d*TortueAvant;
   segment(TortuePos, Temp)
   #declare TortuePos = Temp;
#end
#macro droite(a)
	#local Temp = <0,0,0>;
	#local an = radians(-a);
	#declare Temp = cos(an)*Tortuedroite + sin(an)*TortueAvant;
	#declare TortueAvant = -sin(an)*Tortuedroite + cos(an)*TortueAvant;
	#declare Tortuedroite = Temp;
#end
#macro tangue(a)
	#local Temp = <0,0,0>;
	#local an = radians(a);
	#declare Temp = cos(an)*TortueAvant + sin(an)*TortueHaut;
	#declare TortueHaut = -sin(an)*TortueAvant + cos(an)*TortueHaut;
	#declare TortueAvant = Temp;
#end
#macro roule(a)
	#local Temp = <0,0,0>;
	#local an = radians(-a);
	#declare Temp = cos(an)*Tortuedroite + sin(an)*TortueHaut;
	#declare TortueHaut = -sin(an)*Tortuedroite + cos(an)*TortueHaut;
	#declare Tortuedroite = Temp;
#end
#macro fPos(P)
	segment(TortuePos, P)
	#declare TortuePos = P;
#end
#macro fCap(P)
 #if (P=TortuePos)
 #else
	#local Temp = <P.x,CamPos.y,P.z>-TortuePos;
	#if (Temp = <0,0,0>)
		#declare TortueAvant = vnormalize(P-TortuePos);
		#declare Tortuedroite = <1,0,0>;
		#declare TortueHaut = vcross(Tortuedroite,TortueAvant);
	#else
		#declare Temp = vnormalize(Temp);
		#declare TortueHaut = <0,1,0>;
		#declare Tortuedroite = vcross(Temp,TortueHaut);
		#declare TortueAvant = vnormalize(P-TortuePos);
		#declare TortueHaut = vcross(Tortuedroite,TortueAvant);
	#end
 #end
#end
#macro TC(taille) //TailleCrayon
	#declare TortueEpais = taille*epaisseurTraits;
#end
#macro CC(r,g,b,trans)   //CouleurCrayon
	#declare TortueCouleur = <r/255,g/255,b/255,trans/100>;
#end
#macro CR(r,g,b,trans)   //CouleurRemplissage
	#declare TortueCouleurRemplis = <r/255,g/255,b/255,trans/100>;
#end
#macro BC()   //BaisseCrayon
	#declare TortueCrayon = true;
#end
#macro LC()   //LeveCrayon
	#declare TortueCrayon = false;
#end
#macro debutRemplir()
	#declare TortueRemplis = true;
	#declare TortuePointAncrage = TortuePos;
#end
#macro finRemplir()
	#declare TortueRemplis = false;
#end
#macro segment (P1,P2)
	#if (TortueCrayon)
		object { unCylindre(P1,P2,TortueEpais,false) 
				 texture {pigment {rgbt TortueCouleur }} }
	#end
	#if (TortueRemplis)
		object { triangle {TortuePointAncrage, P1, P2} 
				 texture {pigment {rgbt TortueCouleurRemplis }} }
	#end
#end
 
//************************* FILM 2 ***********************************
//______ squence 1 ______

#declare C1 = <-57, 0, 9>;
#declare C2 = <-47, 15, 9>;
 

#declare P1 = <0, 0, 9>;
#declare P2 = <27, 7, 9>;


//______ squence 3 ______

#declare C3 = <-47, 15, 9>;
#declare C4 = <-57, 0, 9>;
 

#declare P3 = <27, 7, 9>;
#declare P4 = <0, 0, 9>;
//***************** Entrer les # de squences *****************
#declare no_sequence = 2; //Changer les numros de squence  l'aide de la variable "no_sequence".
 

	#if (no_sequence = 1)
		#declare C = C1 - clock*(C1 - C2);
		#declare P = P1 - clock*(P1 - P2);
	#end 
	
	#if (no_sequence = 2)
		#declare C = <-74*cos(clock*pi)+27, 15, 67*sin(clock*pi)+9>;
		#declare P = <27, 7, 9>;
	#end 
	
	#if (no_sequence = 3)
		#declare C = C3 - clock*(C3 - C4);
		#declare P = P3 - clock*(P3 - P4);
	#end 


//***************** Camra, lumires et couleur de fond *****************
#include "colors.inc"


couleurFond(255,255,255)
camera { location  C  look_at   P }
uneLumiere(C)
uneLumiere(<27, 500, 0>) 
background{SummerSky*1.2}
  
//***************** Macro Arbre *****************
  	LC();
  	tangue(90);
   	avance(-8); 
   	BC(); 
   	
#macro arbre(ang, longueur, diametre, coef_longueur, coef_diametre, niveau, niveau_max, couleur_depart, couleur_fin)     
        
         
        #if (niveau<=niveau_max)   
               
        	#if (niveau + 2 < niveau_max) 
        		CC(couleur_depart.x, couleur_depart.y, couleur_depart.z, couleur_depart.t);
        		#else 
        		CC(couleur_fin.x, couleur_fin.y, couleur_fin.z, couleur_fin.t); 
        	#end       
                TC(diametre);
                avance(longueur);
                tangue(-ang);
                arbre(ang, coef_longueur*longueur, coef_diametre*diametre, coef_longueur, coef_diametre, niveau+1, niveau_max, couleur_depart, couleur_fin)
                tangue(ang);
                roule(120);
                tangue(-ang);
                arbre(ang, coef_longueur*longueur, coef_diametre*diametre, coef_longueur, coef_diametre, niveau+1, niveau_max, couleur_depart, couleur_fin)
                tangue(ang);
                roule(120);
                tangue(-ang);
                arbre(ang, coef_longueur*longueur, coef_diametre*diametre, coef_longueur, coef_diametre, niveau+1, niveau_max, couleur_depart, couleur_fin)
                tangue(ang);
                roule(120);
                avance(-longueur);
                
        #end
#end 

//***************** Premier arbre : printemps *****************


arbre(35, 5, 15, 0.75, 0.7, 0, 9, <170, 125, 60, 0>, <255, 150, 220, 0>)

//***************** Deuxime arbre : t *****************

LC();
tangue(-90);
droite(90);
avance(18);
droite(-90);
avance(18);
tangue(90);
BC();
arbre(35, 5, 20, 0.75, 0.7, 0, 8, <170, 125, 60, 0>, <0, 200, 0, 0>)  
  
//***************** Troisime arbre : automne *****************

LC();
tangue(-90);
droite(90);
avance(18);
droite(90);
avance(18);
tangue(90);
BC();
arbre(35, 5, 15, 0.75, 0.7, 0, 9, <170, 155, 60, 0>, <255, 100, 0, 0>)  
  
//***************** Quatrime arbre : hiver *****************

LC();
tangue(-90);
droite(-90);
avance(18);
droite(-90);
avance(18);
tangue(90);
BC();
arbre(35, 5, 15, 0.75, 0.7, 0, 7, <170, 125, 160, 0>, <255, 255, 255, 0>)   
  
//***************** Sol Printemps *****************

#declare TEXTSOL_Printemps = texture { 
pigment { crackle
	color_map { [0.1 color BrightGold*0.4 ] [0.5 color BrightGold*0.65 ] } 
	scale 0.7 } 
normal { 
	granite 2 
	turbulence 0.8 
	scale 0.8 
	accuracy 1 } 
finish { diffuse 0.8 
	ambient 0.5 } 
}  

#declare SOL_Printemps = object
{
  unPrisme(<-200, -8, -200>,<9, -7.9, 200>)
  texture{TEXTSOL_Printemps}  
}

//***************** Sol t *****************

#declare TEXTSOL_Ete = texture { 
pigment { crackle
	color_map { [0.1 color MediumSpringGreen*0.2 ] [0.5 color MediumSpringGreen*0.5 ] } 
	scale 0.7 } 
normal { crackle 2 
	turbulence 0.8 
	scale 0.4 
	accuracy 1 } 
finish { diffuse 0.8 
	ambient 0.5 } 
}  

#declare SOL_Ete = object
{
  unPrisme(<9, -8, -200>,<27, -7.9, 200>)
  texture{TEXTSOL_Ete} 
}

//***************** Sol Automne *****************

#declare TEXTSOL_Automne = texture { 
pigment { crackle 
	color_map { [0.1 color Orange*0.5 ] [0.2 color Orange*0.9 ]} 
	scale 0.7 } 
normal { 
	granite 2 
	turbulence 0.2 
	scale 0.4 
	accuracy 1} 
finish { diffuse 0.7 
	ambient 0.5 } 
}  

#declare SOL_Automne = object
{
  unPrisme(<27, -8, -200>,<45, -7.9, 200>)
  texture{TEXTSOL_Automne}  
}

//***************** Sol Hiver *****************

#declare TEXTSOL_Hiver = texture { 
pigment { crackle
	color_map { [0.3 color White*0.9 ] [0.6 color White*0.5 ] } 
	scale 0.7 } 
normal { granite 0.2 
	turbulence 0.2 
	scale 0.4 
	accuracy 1 } 
finish { diffuse 0.7 
	ambient 0.5 } 
}  

#declare SOL_Hiver = object
{
  unPrisme(<45, -8, -200>,<250, -7.9, 200>) 
  texture{TEXTSOL_Hiver} 
}

//***************** Objets  afficher *****************
SOL_Printemps
SOL_Ete
SOL_Automne
SOL_Hiver


